#define SCLK 2
#define SDIO 3

#include <SimpleMessageSystem.h> 




// ************** ADNS2051 ***********************
// ************** START *********************************/

#define SCLK 2
#define SDIO 3
#define PD 4

#define REG_PRODUCT_ID 0x00
#define REG_REVISION_ID 0x01
#define REG_MOTION 0x02
#define REG_DELTA_X 0x03
#define REG_DELTA_Y 0x04
#define REG_SQUAL 0x05
#define REG_AVERAGE_PIXEL 0x06
#define REG_MAXIMUM_PIXEL 0x07
#define REG_CONFIG_BITS 0x0A
#define REG_DATA_OUT_LOWER 0x0C
#define REG_DATA_OUT_UPPER 0x0D
#define REG_SHUTTER_LOWER 0x0E
#define REG_SHUTTER_UPPER 0x0F
#define REG_FRAME_PERIOD_LOWER 0x10
#define REG_FRAME_PERIOD_UPPER 0x11

#define REG_CONFIGURATION 0x0A
#define REG_PIXEL_DATA 0x0D

//REG_PIXEL_DATA

int dumpWidth = 256; // Number of pixels to read for each frame.
byte frame[256];
int imageWidth = 16;
int imageHeight = 16;
int select = 0;

// ************** ADNS2051 ***********************
// ************** END *********/


/* ************** ADNS2610 ***********************
 ************** START *********************************

#define REG_CONFIGURATION 0x00
#define REG_REVISION_ID 0x01
#define REG_DELTA_X 0x02
#define REG_DELTA_Y 0x03
#define REG_SQUAL 0x04
#define REG_MAXIMUM_PIXEL 0x05
#define REG_MINIMUM_PIXEL 0x05
#define REG_PIXEL_SUM 0x07
#define REG_PIXEL_DATA 0x08
#define REG_SHUTTER_UPPER 0x09
#define REG_SHUTTER_LOWER 0x0A

int dumpWidth = 324; // Number of pixels to read for each frame.
byte frame[324];
int imageWidth = 18;
int imageHeight = 18;
int select = 0;

// ************** ADNS2610 ***********************
// ************** END *********/



void setup() {
  Serial.begin(38400);

  reset();
  
  Serial.println("Just reseted the thing... ");
  Serial.print("VALUES: ");
  Serial.println("Welcome  bl bl to bl dusjagr's bl worm bl on-a-mouse");
  
  pinMode(13, OUTPUT);  
  
  digitalWrite (13, HIGH);
  
  delay(100);
  
  byte config = readRegister(REG_CONFIGURATION); // Forced awake mode, LED allways on
  config |= B00000001; // Don't sleep (LED always powered on).
  writeRegister(REG_CONFIGURATION, config);
  
  delay(100);
  
  dumpWidth = imageWidth * imageHeight;
  
  delay(500);

}

void loop() {
  
  readRegister(REG_MOTION);  
  char dx = readRegister(REG_DELTA_X);
  char dy = readRegister(REG_DELTA_Y);
  delayMicroseconds(500);
  Serial.print("VALUES: "); 
  Serial.print("DELTA: "); 
  Serial.print(dx, DEC);
  Serial.print(" ");
  Serial.print(dy, DEC);

  char squal = readRegister(REG_SQUAL);
  Serial.print(" SQUAL: ");
  Serial.print(squal, DEC);  
  
  char shutter = readRegister(REG_SHUTTER_UPPER);
  Serial.print(" SHUTTER: ");
  Serial.print(shutter, DEC); 

/*
  char sum = readRegister(REG_PIXEL_SUM);
  Serial.print(" SUM: ");
  Serial.println(sum, DEC);
  */
  
  char sum = readRegister(REG_AVERAGE_PIXEL);
  Serial.print(" AVERAGE: ");
  Serial.println(sum, DEC);
  
  
  //Serial.println();

  if (messageBuild() > 0) {
    switch (messageGetChar()) {
      case 's':
        select = 0;
        break;
      
      case 'd':
        select = 1;
        break;
    }
  }
 
 
   if (select == 0) {
    dumpWidth = imageWidth * imageHeight;
    delay(20);
    frameSingleA2051();
    }
 
    if (select == 1) {
      dumpWidth = imageWidth*1;
      frameDump();
    }
  
  
     
  Serial.println();
  
  //delay(10);
  
}


void frameSingleA2051() {
  
  byte config = readRegister(REG_CONFIG_BITS);
  config |= B00001000; // PixDump
  writeRegister(REG_CONFIG_BITS, config);

  delayMicroseconds(500);
  int count = 0;
  
  Serial.println(" NORMAL: "); 
  
  Serial.print("#");
   
 // imageWidth = 16;
  // imageHeight = 16;
  
  do {
    byte data = readRegister(REG_DATA_OUT_LOWER);
    
    if( (data & 0x80) == 0 ) { // Data is valid
      frame[count++] = ((data & B00111111));  
      }
    
      Serial.print(frame[count]<<2, DEC);
      Serial.print(",");
      
      delayMicroseconds(1);
    
    } 

  while (count != dumpWidth);
  Serial.println("%"); //37
  //delay(200);
}

void frameSingleA2610() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count = 0;
  
  Serial.println(" NORMAL: "); 
  
  Serial.print("#");
   
 // imageWidth = 16;
  // imageHeight = 16;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111));  
       
      Serial.print(frame[count]<<2, DEC);
      Serial.print(",");
      
      delayMicroseconds(10);
    
    } 

  while (count != dumpWidth);
  Serial.println("%"); //37
  //delay(200);
}


void frameDump() {
  
  //delayMicroseconds(1);
  
  imageWidth = 1;
  imageHeight = 1;
  
  Serial.println(" DUMP:"); 
  
  
}

// ************** ADNS2051 ***********************
// ************** ##################### **********


// ************** reset the ADNS chip **********

void reset() {
  pinMode(SCLK, OUTPUT);
  pinMode(SDIO, INPUT);
  pinMode(PD, OUTPUT);
  digitalWrite(SCLK, LOW);
  digitalWrite(PD, HIGH);
  delayMicroseconds(1);
  digitalWrite(PD, LOW);
}

// ************** listen to the ADNS chip **********

byte readRegister(byte address) {
  pinMode (SDIO, OUTPUT);

  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  pinMode (SDIO, INPUT);

  delayMicroseconds(100); // tHOLD = 100us min.

  byte res = 0;
  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SCLK, HIGH);
    if( digitalRead (SDIO) == HIGH )
      res |= i;
  }

  return res;
}


// ************** talk to the ADNS chip **********

void writeRegister(byte address, byte data) {
  address |= 0x80; // MSB indicates write mode.
  pinMode (SDIO, OUTPUT);

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (data & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  delayMicroseconds(100); // tSWW, tSWR = 100us min.
}
