#include <SimpleMessageSystem.h> 

int soundPin = 10;

// ************** serLCD ***********************
// ************** START *********************************/

int pwm = 100;
int speedPWM = 20;
int delayWrite = 20;
int val = 0;



// ************** ADNS2051 ***********************
// ************** START *********************************/

#define SCLK 2
#define SDIO 3
#define PD 4

#define REG_PRODUCT_ID 0x00
#define REG_REVISION_ID 0x01
#define REG_MOTION 0x02
#define REG_DELTA_X 0x03
#define REG_DELTA_Y 0x04
#define REG_SQUAL 0x05
#define REG_AVERAGE_PIXEL 0x06
#define REG_MAXIMUM_PIXEL 0x07
#define REG_CONFIG_BITS 0x0A
#define REG_DATA_OUT_LOWER 0x0C
#define REG_DATA_OUT_UPPER 0x0D
#define REG_SHUTTER_LOWER 0x0E
#define REG_SHUTTER_UPPER 0x0F
#define REG_FRAME_PERIOD_LOWER 0x10
#define REG_FRAME_PERIOD_UPPER 0x11

#define REG_CONFIGURATION 0x0A
#define REG_PIXEL_DATA 0x08

int dumpWidth = 256; // Number of pixels to read for each frame.
byte frame[256];
int imageWidth = 16;
int imageHeight = 16;
int select = 0;

// ************** ADNS2051 ***********************
// ************** END *********/


/* ************** ADNS2610 ***********************
 ************** START *********************************

#define REG_CONFIGURATION 0x00
#define REG_REVISION_ID 0x01
#define REG_DELTA_X 0x02
#define REG_DELTA_Y 0x03
#define REG_SQUAL 0x04
#define REG_MAXIMUM_PIXEL 0x05
#define REG_MINIMUM_PIXEL 0x05
#define REG_PIXEL_SUM 0x07
#define REG_PIXEL_DATA 0x08
#define REG_SHUTTER_UPPER 0x09
#define REG_SHUTTER_LOWER 0x0A

int dumpWidth = 324; // Number of pixels to read for each frame.
byte frame[324];
int imageWidth = 18;
int imageHeight = 18;
int select = 0;

// ************** ADNS2610 ***********************
// ************** END *********/



void setup() {
  Serial.begin(9600);

  backlightOff();
  clearLCD();
  delay(50);

  backlightOn();
 
  delay(50);

  

  reset();
  dimmSiechOff();
  dimmSiechOn();
  
  backlightPWM();
  
  pinMode(13, OUTPUT);  
  
  digitalWrite (13, HIGH);
  
  delay(100);
  
  byte config = readRegister(REG_CONFIGURATION); // Forced awake mode, LED allways on
  config |= B00000001; // Don't sleep (LED always powered on).
  writeRegister(REG_CONFIGURATION, config);
  
  delay(100);
  
  dumpWidth = imageWidth * imageHeight;
  
  delay(1500);
  
  pinMode(soundPin, OUTPUT);

}

void loop() {
    
  char dx = readRegister(REG_DELTA_X);
  delayMicroseconds(500);
  char dy = readRegister(REG_DELTA_Y);
  delayMicroseconds(500);
  
  char squal = readRegister(REG_SQUAL);
  delayMicroseconds(500);
  
  char sum = readRegister(REG_AVERAGE_PIXEL);
  delayMicroseconds(500);

    
  selectLineOne();
  delay(delayWrite);
  Serial.print("SQUAL: ");
  delay(delayWrite);
  Serial.print(squal, DEC);  
  
  Serial.print("     ");

  selectLineTwo();
  delay(delayWrite);
  //Serial.print("DELTA: "); 
  Serial.print("AVERAGE: ");
  delay(delayWrite);
  //Serial.print(dx, DEC);
  Serial.print(sum, DEC);
  
  Serial.print("     ");

  if (squal > 15) {
    
   tone(10, squal<<3, 30);;
  }
  
}


void frameSingleA2051() {
  
  byte config = readRegister(REG_CONFIG_BITS);
  config |= B00001000; // PixDump
  writeRegister(REG_CONFIG_BITS, config);

  delayMicroseconds(500);
  int count = 0;
  
  Serial.println(" NORMAL: "); 
  
  Serial.print("#");
   
 // imageWidth = 16;
  // imageHeight = 16;
  
  do {
    //byte data = readRegister(REG_PIXEL_DATA);
    byte data = readRegister(REG_DATA_OUT_LOWER);
    
    if( (data & 0x80) == 0 ) { // Data is valid
      frame[count++] = ((data & B00111111));  
      }
    
      Serial.print(frame[count]<<2, DEC);
      Serial.print(",");
      
      delayMicroseconds(200);
    
    } 

  while (count != dumpWidth);
  Serial.println("%"); //37
  //delay(200);
}

void frameSingleA2610() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count = 0;
  
  Serial.println(" NORMAL: "); 
  
  Serial.print("#");
   
 // imageWidth = 16;
  // imageHeight = 16;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111));  
       
      Serial.print(frame[count]<<2, DEC);
      Serial.print(",");
      
      delayMicroseconds(200);
    
    } 

  while (count != dumpWidth);
  Serial.println("%"); //37
  //delay(200);
}


void frameDump() {
  
  //delayMicroseconds(1);
  
  imageWidth = 1;
  imageHeight = 1;
  
  Serial.println(" DUMP:"); 
  
  
}

// ************** ADNS2610 ***********************
// ************** ##################### **********


// ************** reset the ADNS chip **********

void reset() {
  pinMode(SCLK, OUTPUT);
  pinMode(SDIO, INPUT);
 
  digitalWrite(SCLK, LOW);

  delayMicroseconds(100);

}

// ************** listen to the ADNS chip **********

byte readRegister(byte address) {
  pinMode (SDIO, OUTPUT);

  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  pinMode (SDIO, INPUT);

  delayMicroseconds(500); // tHOLD = 100us min.

  byte res = 0;
  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SCLK, HIGH);
    if( digitalRead (SDIO) == HIGH )
      res |= i;
  }

  return res;
}


// ************** talk to the ADNS chip **********

void writeRegister(byte address, byte data) {
  address |= 0x80; // MSB indicates write mode.
  pinMode (SDIO, OUTPUT);

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (data & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  delayMicroseconds(500); // tSWW, tSWR = 100us min.
}



void selectLineOne(){  //puts the cursor at line 0 char 0.
   Serial.print(0xFE, BYTE);   //command flag
   Serial.print(128, BYTE);    //position
}
void selectLineTwo(){  //puts the cursor at line 0 char 0.
   Serial.print(0xFE, BYTE);   //command flag
   Serial.print(192, BYTE);    //position
}
void goTo(int position) { //position = line 1: 0-15, line 2: 16-31, 31+ defaults back to 0
if (position<16){ Serial.print(0xFE, BYTE);   //command flag
              Serial.print((position+128), BYTE);    //position
}else if (position<32){Serial.print(0xFE, BYTE);   //command flag
              Serial.print((position+48+128), BYTE);    //position 
} else { goTo(0); }
}

void clearLCD(){
   Serial.print(0xFE, BYTE);   //command flag
   Serial.print(0x01, BYTE);   //clear command.
}
void backlightOn(){  //turns on the backlight
    Serial.print(0x7C, BYTE);   //command flag for backlight stuff
    Serial.print(157, BYTE);    //light level.
}
void backlightOff(){  //turns off the backlight
    Serial.print(0x7C, BYTE);   //command flag for backlight stuff
    Serial.print(128, BYTE);     //light level for off.
}
void serCommand(){   //a general function to call the command flag for issuing all other commands   
  Serial.print(0xFE, BYTE);
}

void backlightPWM(){  //turns off the backlight
    Serial.print(0x7C, BYTE);   //command flag for backlight stuff
    Serial.print(pwm, BYTE);     //light level for off.
}

void dimmSiechOn(){
  for (pwm=128;pwm<157;pwm++){
    backlightPWM();
    delay(speedPWM);
  }
}

void dimmSiechOff(){
  for (pwm=157;pwm>128;pwm--){
    backlightPWM();
    delay(speedPWM);
  }
}
