#define SCLK 2
#define SDIO 3

#include "pitches.h"
#include <SimpleMessageSystem.h> 

// notes in the melody:
int melody[] = {
  NOTE_C4, NOTE_G3,NOTE_G3, NOTE_A3, NOTE_G3,0, NOTE_B3, NOTE_C4};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  16, 32, 32, 16,16,16,16,16 };

#define REG_CONFIGURATION 0x00
#define REG_REVISION_ID 0x01
#define REG_DELTA_X 0x02
#define REG_DELTA_Y 0x03
#define REG_SQUAL 0x04
#define REG_MAXIMUM_PIXEL 0x05
#define REG_MINIMUM_PIXEL 0x05
#define REG_PIXEL_SUM 0x07
#define REG_PIXEL_DATA 0x08
#define REG_SHUTTER_UPPER 0x09
#define REG_SHUTTER_LOWER 0x0A


int dumpWidth = 324; // Number of pixels to read for each frame.
byte frame[324];
byte frame1[324];
byte frame2[324];
byte frame3[324];
int imageWidth = 18;
int imageHeight = 18;
int select = 0;

void setup() {
  Serial.begin(115200);

  reset();
  
  Serial.println("Just reseted the thing... ");
  Serial.print("VALUES: ");
  Serial.println("Welcome  bl bl to bl dusjagr's bl worm bl on-a-mouse");
  
  delay(100);
  
  byte config = readRegister(REG_CONFIGURATION); // Forced awake mode, LED allways on
  config |= B00000001; // Don't sleep (LED always powered on).
  writeRegister(REG_CONFIGURATION, config);
  
  delay(100);
  
 for (int thisNote = 0; thisNote < 8; thisNote++) {

    int noteDuration = 1000/noteDurations[thisNote];
    tone(10, melody[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
  }
  
  dumpWidth = 18 * 18;
  
  delay(500);

}

void loop() {
    
  char dx = readRegister(REG_DELTA_X);
  char dy = readRegister(REG_DELTA_Y);
  delayMicroseconds(500);
  Serial.print("VALUES: "); //remove SPACE for mousecam
  Serial.print("DELTA: "); //remove SPACE for mousecam
  Serial.print(dx, DEC);
  Serial.print(" ");
  Serial.print(dy, DEC);

  char squal = readRegister(REG_SQUAL);
  Serial.print(" SQUAL: ");
  Serial.print(squal, DEC);  
  
  char shutter = readRegister(REG_SHUTTER_UPPER);
  Serial.print(" SHUTTER: ");
  Serial.print(shutter, DEC); 

  char sum = readRegister(REG_PIXEL_SUM);
  Serial.print(" SUM: ");
  Serial.println(sum, DEC);
  
  
  //Serial.println();

  if (messageBuild() > 0) {
    switch (messageGetChar()) {
      case 's':
        select = 0;
        break;
      
      case 'a':
        select = 1;
        break;
      
      case 'd':
        select = 2;
        break;
     
      case 'f':
        select = 3;
         break;
    }
  }
  
  if (select == 1) {
    frameAverage();
    dumpWidth = 18 * 18;
  }
  
  if (select == 0) {
    dumpWidth = 18 * 18;
    delay(20);
    frameSingle();
    }
  
    if (select == 2) {
      dumpWidth = 18*1;
      frameDump();
    }
     
    if (select == 3) {
      dumpWidth = 18*5;
      frameFive();
    }
  

  Serial.println();
  
  
}


void frameSingle() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count = 0;
  
  Serial.println(" NORMAL: "); 
  
  Serial.print("#");
   
  imageWidth = 18;
  imageHeight = 18;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111));  
       
      Serial.print(frame[count]<<2, DEC);
      Serial.print(",");
      
      delayMicroseconds(200);
    
    } 

  while (count != dumpWidth);
  Serial.println("%"); //37
  //delay(200);
}

void frameFast() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(800);
  int count = 0;
  
  Serial.println(" FAST: "); 
  
  imageWidth = 18;
  imageHeight = 18;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111)); //adjust brigthness 
       
      Serial.print(frame[count]<<2, DEC);
      Serial.println();
      delayMicroseconds(30);
    } 

  while (count != dumpWidth);

}



void frameDump() {
  
  //delayMicroseconds(1);
  
  imageWidth = 1;
  imageHeight = 1;
  
  Serial.println(" DUMP:"); 
  
  
}


void frameFive() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count = 0;

  Serial.println(" SMALL25: "); 

  imageWidth = 5;
  imageHeight = 5;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111)); //adjust brigthness  
      delayMicroseconds(512);
    } 

  while (count != dumpWidth);

  
  
  for(int i = 0; i < imageHeight; i++) {
    for(int j = 0; j < imageWidth; j++) {
      byte pix = (frame[(i*18) + j]<<2);
    
      
      Serial.print(pix, DEC);
      Serial.println();
      //delay(5);
    }  
  }
}

void frameAverage() {
  
  byte config = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count = 0;
  
  imageWidth = 18;
  imageHeight = 18;
  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame[count++] = ((data & B00111111)); //adjust brigthness  
      delayMicroseconds(512);
    
    } 
  
  while (count != dumpWidth);
  
  byte config1 = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count1 = 0;
  

  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame1[count1++] = ((data & B00111111)); //adjust brigthness  
      delayMicroseconds(512);
    } 

  while (count1 != dumpWidth);
  
    byte config2 = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count2 = 0;
  

  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame2[count2++] = ((data & B00111111)); //adjust brigthness  
      delayMicroseconds(512);
    } 

  while (count2 != dumpWidth);
  
    byte config3 = readRegister(REG_PIXEL_DATA);
  config |= B01000000; // PixDump
  writeRegister(REG_PIXEL_DATA, config);

  delayMicroseconds(500);
  int count3 = 0;
  

  
  do {
    byte data = readRegister(REG_PIXEL_DATA);
      frame3[count3++] = ((data & B00111111)); //adjust brigthness  
      delayMicroseconds(512);
    } 

  while (count3 != dumpWidth);


  Serial.println(" AVERAGE:"); 
  
  for(int i = 0; i < imageHeight; i++) {
    for(int j = 0; j < imageWidth; j++) {
      byte pix = (frame[(i*18) + j]+frame1[(i*18) + j]+frame2[(i*18) + j]+frame3[(i*18) + j]);
            
      Serial.print(pix, DEC);
      Serial.println();
    }  
  }
}


void reset() {
  pinMode(SCLK, OUTPUT);
  pinMode(SDIO, INPUT);
 
  digitalWrite(SCLK, LOW);

  delayMicroseconds(1);

}

byte readRegister(byte address) {
  pinMode (SDIO, OUTPUT);

  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  pinMode (SDIO, INPUT);

  delayMicroseconds(10); // tHOLD = 100us min.

  byte res = 0;
  for (byte i=128; i >0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SCLK, HIGH);
    if( digitalRead (SDIO) == HIGH )
      res |= i;
  }

  return res;
}

void writeRegister(byte address, byte data) {
  address |= 0x80; // MSB indicates write mode.
  pinMode (SDIO, OUTPUT);

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (address & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  for (byte i = 128; i > 0 ; i >>= 1) {
    digitalWrite (SCLK, LOW);
    digitalWrite (SDIO, (data & i) != 0 ? HIGH : LOW);
    digitalWrite (SCLK, HIGH);
  }

  delayMicroseconds(100); // tSWW, tSWR = 100us min.
}
